<?

require_once "ziplib.php";
require_once "F_utils.php";

function ExtractArchive($name, $to, $mk_subdirs = 0)
{
	tolog('b',"Extracting $name to $to");
if (is_file($name)):
	$Archive = new ZipReader($name);
	$file_data = $Archive->ReadFile();
	while($file_data[0]):
		if ($mk_subdirs) pc_mkdir_parents($to.'/'.dirname($file_data[0]));
		if ($file_data[1] || !$mk_subdirs):
			$outf = fopen("$to/{$file_data[0]}",'w');
			fwrite($outf, $file_data[1]);
			fclose($outf);
			$result[] = $file_data[0];
		endif;
		$file_data = $Archive->ReadFile();
	endwhile;
	$Archive->done();
endif;
return $result;
}

function AddToArchive($arch,$fn,$tmp)
{
	tolog('b',"Adding $fn to $arch");
	$p_files = array();
	if (is_file($arch)):
		$p_files = ExtractArchive($arch,$tmp);
	endif;
	$Archive = new ZipWriter('',$arch);
	foreach($p_files as $fname):
	$Archive->addRegularFile(basename("$tmp/$fname"),file_get_contents("$tmp/$fname"));
	unlink("$tmp/$fname");
	endforeach;
	$Archive->addRegularFile(basename($fn),file_get_contents($fn));
	$Archive->finish();
	chmod($arch,0666);
}

function Get_Content_from_zip($fname)
{
	$Archive = new ZipReader($fname);
	$file_data = $Archive->ReadFile();
	$Archive->done();
	return $file_data[1];
}

?>
