<?

require_once 'S_config.php';
require_once 'F_utils.php';
require_once 'F_archives.php';
require_once "C_msgbase.php";
require_once "F_pkt.php";
require_once "A_common.php";

function Sort_nodes($a,$b)
{
	list($n1,$f1) = split('/',$a);
	list($n2,$f2) = split('/',$b);
	$r = $n1 - $n2;
	if ($r == 0)
		$r = $f1 - $f2;
	return $r;
}

function join_to_80_wpp($array,$prefix)
{
	$strs='';
	$item = array_shift($array);
	while ($item):
		$line = $prefix.$item;
		$item = '';
		while ($array):
			$item = array_shift($array);
			if (strlen($line.' '.$item)>80):
				break;
			else:
				$line.= ' '.$item;
			endif;
		endwhile;
		$strs.= $line."\r";
	endwhile;
	return $strs;
}

function AddSeenByAndPath($message,$links,$ouraka,$from,$to)
{
	GLOBAL $CONFIG;
	$path = '';
	$seenby = '';
	$resmsg = '';
	$sepmsg = '';
	$wpath = false;
	
	$message = str_replace("\r","\r".chr(0),$message);
	$line = strtok($message,"\r");
	while($line):
		if (strcmp(substr($line,0,1),chr(0))==0) $line = substr($line,1);
		if (strcmp(substr($line,0,7),chr(1).'PATH: ')==0):
			$path = trim(substr($line,7));
			$wpath = true;
			break;
		elseif (strcmp(substr($line,0,9),'SEEN-BY: ')==0):
			$sepmsg.= $line."\r";
			$seenby.= ($seenby?' ':'').trim(substr($line,9));
		else:
			$resmsg.= $sepmsg.$line."\r";
			$sepmsg = '';
			$seenby = '';
			$path = '';
		endif;
		$line = strtok("\r");
	endwhile;

//	$resmsg = '123123';
	
	$seens = $seenby?(split(' ',$seenby)):array();
	$paths = $path?(split(' ',$path)):array();
	$szs = sizeof($seens);
	$szp = sizeof($paths);
	for ($i=0; $i<$szs; $i++):
		$p = strpos($seens[$i],'/');
		if ($p === false):
			$seens[$i] = $net.'/'.$seens[$i];
		else:
			$net = substr($seens[$i],0,$p);
		endif;
	endfor;
	$zg = false;
	$tozone = false;
	if (!$CONFIG->GetVar('nozonegating')):
		$zg = true;
		$zone = false;
		$tozone = false;
		if (($p = strpos($from,':'))!==false):
			$zone = substr($from,0,$p);
		elseif (($p = strpos($ouraka,':'))!==false):
			$zone = substr($ouraka,0,$p);
		endif;
		if (($p = strpos($to,':'))!==false):
			$tozone = substr($to,0,$p);
		endif;
		$strip = ($zone && $tozone && ($zone != $tozone));
		if ($strip) $seens = array();
	endif;
	$l2 = $links;
	$l2[] = $ouraka;
	foreach($l2 as $l):
		$zone = strtok($l,':');
		$net = strtok('/');
		$node = strtok('.');
		$point = strtok('@');
		if (!$point):
			if (!$tozone || ($zone == $tozone) || !$zg):
				if (!in_array($addr2d = $net.'/'.$node,$seens)):
					$seens[] = $addr2d;
				endif;
			endif;
		endif;
	endforeach;
	usort($seens,'Sort_nodes');

	for ($i=0; $i<$szp; $i++):
		$p = strpos($paths[$i],'/');
		if ($p === false):
			$paths[$i] = $net.'/'.$paths[$i];
		else:
			$net = substr($paths[$i],0,$p);
		endif;
	endfor;
	$zone = strtok($ouraka,':');
	$net = strtok('/');
	$node = strtok('.');
	$point = strtok('@');
	if (!$point):
		if (strcmp($paths[$szp-1],$addr2d = $net.'/'.$node)!=0):
			$paths[] = $addr2d;
		endif;
	endif;

	$seenby = join_to_80_wpp($seens,'SEEN-BY: ');
	$path = join_to_80_wpp($paths,chr(1).'PATH: ');
	if (!$wpath) $resmsg.= $sepmsg.$line;
	return $resmsg.$seenby.$path;
}

function PackToLink($pkt,$addr)
{
	GLOBAL $CONFIG;
	GLOBAL $Outbound;
	tolog('K',"Packing $pkt to $addr");
	$OutMail = $Outbound->GetMailTo($addr);
	foreach($OutMail as $fname):
		if (preg_match('/^[0-9a-z]{8}.(su|mo|tu|we|th|fr|sa)[0-9a-z]$/i',basename($fname))) {$ArchName = $fname;}
	endforeach;
	list($path,$file) = $Outbound->get_link_filename($addr);
	pc_mkdir_parents($path,0777);
	if (!isset($ArchName)) { 
	srand((double)microtime()*1000000);
	$ArchName = $path.'/'.rand(10000000,99999999).'.'.strtolower(substr(date('D'),0,2)).'0';
	$LoName = "$path/$file.flo";
	$loshka = fopen($LoName,'a');
	fwrite($loshka,basename($ArchName)."\n");
	fclose($loshka);
	chmod($LoName,0666);
	}
	AddToArchive($ArchName,$pkt,$CONFIG->Vars['tempoutbound']);
	unlink($pkt);
	tolog('k',"Finished. Deleting $pkt");
}

function ExtractBundles($inbound,$temp)
{
	tolog('b',"Finding bundles in $inbound");
	$in_dir = opendir($inbound);
	while ($fname = readdir($in_dir)):
	tolog('b',"Found file $fname");
		if (preg_match('/^[0-9a-z]{8}\.(su|mo|tu|we|th|fr|sa)[0-9]$/i',$fname))
		{
			tolog('B',"Found bundle $fname");
			foreach(ExtractArchive("$inbound/$fname",$temp) as $item)
			{
			    tolog('B',"Unpacking file $item");
			}
			unlink($inbound.'/'.$fname);
			tolog('D',"Deleting file $fname");
		}
	endwhile;
}

function Process_message_Ptosser($message,$addr)
{
	GLOBAL $CONFIG;
	GLOBAL $OutPkts;
	GLOBAL $OutPktNames;
	$MsgText = $message->MsgText;
	$Origin_addr = '';
	$line = strtok($MsgText,chr(13));
	if (strcasecmp(substr($line,0,5),'area:')==0):
		$Cludges['area'] = trim(substr($line,5));
		$MsgText = substr($MsgText,strpos($MsgText,chr(13))+1);
		$line = strtok($MsgText,chr(13));
	endif;
	while($line):
		if (strcmp(substr($line,0,1),chr(1))==0):
			$arr = split(':',substr($line,1),2);
			if (sizeof($arr) == 2):
				$key = strtolower(trim($arr[0]));
				$value = trim($arr[1]);
				$Cludges[$key] = $value;
			endif;
			elseif (strcmp(substr($line,0,3),' * ')==0):
			$Origin_addr = strtok(substr(substr($line,0,strrpos($line,')')),strrpos($line,'(')+1),'@');
		endif;
		$line = strtok(chr(13));
	endwhile;

	if (!isset($Cludges['area'])) { $Cludges['area'] = 'Netmail'; }
	
	tolog('t',"New message in area {$Cludges['area']}");

	if (($areanum = $CONFIG->Areas->FindAreaNum($Cludges['area']))==-1):
		tolog('T',"Creating area {$Cludges['area']}");
		$AreaDef = new C_AreaDef('');
		$AreaDef->EchoTag = strtoupper($Cludges['area']);
		$AreaDef->Path = $CONFIG->Vars['msgbase'].'/'.strtolower($Cludges['area']);
		$AreaDef->Status = 'Echoarea';
		$options = split(' ',$CONFIG->Vars['autocreatedefaults']);
		$optsize = sizeof($options);
		for ($i=0;$i<$optsize;$i+=2):
		$AreaDef->Options[$options[$i]] = $options[$i+1];
		endfor;
		$AreaDef->Links[] = Get_address($addr);
		$descr = GetEchoDescrFromEcholist($Cludges['area']);
		if ($descr) { $AreaDef->Options['-d'] = "\"$descr\""; }
		$CONFIG->Areas->AppendAreaToConf($AreaDef->AppendArea($CONFIG->GetVar('autocreateareasfile')));
	endif;
	
	$Area = new C_msgbase;

	if (isset($CONFIG->Areas->Vals)):
	foreach ($CONFIG->Areas->Vals[$CONFIG->Areas->FindAreaNum($Cludges['area'])]->Links as $packto):
	if (strcmp(Get_address($addr),$packto)!=0):
		if (!isset($OutPkts[$packto])):
			srand((double)microtime()*1000000);
			$pktname = $CONFIG->Vars['tempoutbound'].'/'.rand(10000000,99999999).'.pkt';
			$OutPktNames[$packto] = $pktname;
			tolog('k',"New PKT file - $pktname");
			$OutPkts[$packto] = new FidoPacket;
			$OutPkts[$packto]->NewPacket($pktname,$CONFIG->GetVar('address'),$packto,'');
		endif;
		tolog('k',"Packing message for $packto");
		$OutPkts[$packto]->message->Version = 2;
		$OutPkts[$packto]->message->OrigNode = $message->OrigNode;
		$OutPkts[$packto]->message->DestNode = $message->DestNode;
		$OutPkts[$packto]->message->OrigNet = $message->OrigNet;
		$OutPkts[$packto]->message->DestNet = $message->DestNet;
		$OutPkts[$packto]->message->Attr = $message->Attr;
		$OutPkts[$packto]->message->Cost = $message->Cost;
		$OutPkts[$packto]->message->AsciiDate = $message->AsciiDate;
		$OutPkts[$packto]->message->ToUser = $message->ToUser;
		$OutPkts[$packto]->message->FromUser = $message->FromUser;
		$OutPkts[$packto]->message->Subject = $message->Subject;
		$Text = AddSeenByAndPath($message->MsgText,$CONFIG->Areas->Vals[$areanum]->Links,$CONFIG->GetVar('address'),Get_address($addr),$packto);
		$OutPkts[$packto]->message->MsgText = $Text;
		$OutPkts[$packto]->AppendMessage();
		tolog('k','Packing finished');
	endif;
	endforeach;
	endif;
	
	$Area->Open($Cludges['area'],1);
	$header = new C_msgheader;
	$header->Attrs = 0;
	$header->From = $message->FromUser;
	$header->To = $message->ToUser;
	$header->Subj = $message->Subject;
	$header->FromAddr = $Origin_addr;
	$header->ToAddr = 0;
	$header->WDate = Fts_date_to_unix($message->AsciiDate);
	$header->ADate = mktime();
	$Area->WriteMessage($header,$MsgText);
	$Area->Close();
	tolog('t','Tossing message finished');
}

function Toss_Pkt($name)
{
	tolog('T',"Tossing file $name");
	$packet = new FidoPacket;
	$packet->Open($name);
	$from_pkt = array($packet->pkt_hat->OrigZone,$packet->pkt_hat->OrigNet,$packet->pkt_hat->OrigNode,$packet->pkt_hat->OrigPoint);
	$message = $packet->ReadMessage();
	while ($message->Version!=0):
		Process_message_Ptosser($message,$from_pkt);
		$message = $packet->ReadMessage();
	endwhile;
	$packet->Close();
	tolog('t','Tossing finished');
	unlink($name);
}

function Run_tosser()
{
	GLOBAL $CONFIG;
	GLOBAL $OutPkts;
	GLOBAL $OutPktNames;
	$tempin = $CONFIG->Vars['tempinbound'];
	$inbound = $CONFIG->Vars['inbound'];
	$OutPkts = array();
	$OutPktNames = array();
	ExtractBundles($inbound,$tempin);
	$dir = opendir($inbound);
	while ($fname = readdir($dir))
	{ 
		if (preg_match('/\.pkt$/i',$fname)):
		Toss_Pkt("$inbound/$fname"); 
		endif;
	}
	closedir($dir);
	$dir = opendir($tempin);
	while ($fname = readdir($dir))
	{ 
		if (preg_match('/\.pkt$/i',$fname)):
		Toss_Pkt("$tempin/$fname"); 
		endif;
	}
	closedir($dir);
	if ($OutPkts):
	$links = array_keys($OutPkts);
	foreach($links as $addr):
	$OutPkts[$addr]->FinishPacket();
	PackToLink($OutPktNames[$addr],$addr);
	endforeach;
	endif;
}

function ScanMessage($area,$msg,$Area = false,$header = false)
{
	$openb = $Area === false;
	GLOBAL $CONFIG;
	$areanum = $CONFIG->Areas->FindAreaNum($area);
	if (!$CONFIG->Areas->Vals[$areanum]->Links):
		tolog('K','Nobody to pack');
	else:
		if ($openb):
			$Area = new C_msgbase;
			$Area->Open($area);
		endif;
		if ($header === false) $header = $Area->ReadMsgHeader($msg);
		$MessageText = "AREA: ".strtoupper($area)."\r".chr(1).'TID: Phfito 0.075'.$Area->ReadMsgBody($msg);
		foreach($CONFIG->Areas->Vals[$areanum]->Links as $addr):
			srand((double)microtime()*1000000);
			$pktname = $CONFIG->Vars['outbound'].'/'.rand(10000000,99999999).'.pkt';
			$MessageText = AddSeenByAndPath($MessageText,$CONFIG->Areas->Vals[$areanum]->Links,$CONFIG->GetVar('address'),'',$addr);
			tolog('k',"Packing $pktname for $addr");
			preg_match('/:([0-9]+)\/([0-9]+)/',$header->FromAddr,$m);
			preg_match('/:([0-9]+)\/([0-9]+)/',$header->ToAddr,$t);
			$OutPkt = new FidoPacket;
			$OutPkt->NewPacket($pktname,$CONFIG->GetVar('address'),$addr,'');
			$OutPkt->message->Version = 2;
			$OutPkt->message->OrigNode = $m[1];
			$OutPkt->message->DestNode = $m[2];
			$OutPkt->message->OrigNet = $t[1];
			$OutPkt->message->DestNet = $t[2];
			$OutPkt->message->Attr = 0;
			$OutPkt->message->Cost = 0;
			$OutPkt->message->AsciiDate = date('d M y  H:i:s',$header->WDate);
			$OutPkt->message->ToUser = $header->To;
			$OutPkt->message->FromUser = $header->From;
			$OutPkt->message->Subject = $header->Subj;
			$OutPkt->message->MsgText = $MessageText;
			$OutPkt->AppendMessage();
			$OutPkt->FinishPacket();
			tolog('k','Packing finished');
			PackToLink($pktname,$addr);
		endforeach;
		if ($openb):
			$Area->Close();
		endif;
	endif;
}

function ScanArea($area)
{
	tolog('S',"Scanning area $area");
	$Area = new C_msgbase;
	if ($Area->Open($area)):
		$ms = $Area->GetNumMsgs();
		for ($i=1;$i<=$ms;$i++):
			$header = $Area->ReadMsgHeader($i);
			$attr = $header->Attrs;
			if (($attr & MSG_LOC)&& !($attr & MSG_SNT)):
				ScanMessage($area,$i,$Area,$header);
				$Area->SetAttr($i,$attr | MSG_SNT | MSG_SCN);
			endif;
		endfor;
	endif;
}

function ScanAllAreas()
{
	GLOBAL $CONFIG;
	foreach ($CONFIG->Areas->Vals as $area):
		ScanArea($area->EchoTag);
	endforeach;
}

?>
