<?

function aks_init($module = false)
{
	GLOBAL $CONFIG;
	GLOBAL $Outbound;
	set_error_handler('Error_handler');
	$CONFIG = new C_CONFIG();
	if (is_file('config')):
		$CONFIG->Open('config',$module);
	endif;
	initlog();
	if (isset($CONFIG->Vars['outbound'])):
		include_once "A_common.php";
		$Outbound = new C_BSO_Outbound($CONFIG->Vars['outbound']);
	endif;
}

function aks_done()
{
	donelog();
	unset($Outbound);
}

function param_split($line)
{
	$num = 0;
	$kav = 0;
	$emp = 0;
	$result = array('');
	$s = strlen($line);
	for($i=0;$i<$s;$i++):
		switch($line{$i}):
			case("\""):
				if ($kav):
					$kav = 0;
					$emp = 0;
				else:
					if (!$emp):
						$result[++$num] = '';
						$emp = 1;
					endif;
					$kav = 1;
				endif;
				break;
			case(" "):
				if ($kav):
					$result[$num].= ' ';
					$emp = 0;
				else:
					if (!$emp):
				   		$result[++$num] = '';
						$emp = 1;
					endif;
				endif;
				break;
			default:
				$result[$num].= $line{$i};
				$emp = 0;
		endswitch;
	endfor;
	return $result;
}

class C_configfile_reader
{
	var $file;
	var $iflvl;
	var $Levels;
	var $LvlsPs;
	
	function C_configfile_reader($filename)
	{
		$this->file = fopen($filename,'r');
		$this->iflvl = 0;
		$this->Levels[0] = 1;
		$this->LvlsPs[0] = 1;
	}

	function ReadStr()
	{
		if (!$this->file) return false;
		$line = fgets($this->file,10240);
		if (!$line) return false; 
		$line = trim($line);
		$line = $this->read_and_translate($line);

		if (strcmp(substr($line,0,3),'if ')==0):
			if ($this->Levels[$this->iflvl++]):
				$this->LvlsPs[$this->iflvl] = $this->Levels[$this->iflvl] = $this->is_equal(substr($line,3));
			else:
				$this->Levels[$this->iflvl] = 0;
				$this->LvlsPs[$this->iflvl] = 1;
			endif;
			return '';
		elseif (strcmp(substr($line,0,7),'elseif ')==0):
			if (!$this->LvlsPs[$this->iflvl]):
				$this->LvlsPs[$this->iflvl] = $this->Levels[$this->iflvl] = $this->is_equal(substr($line,7));
			else:
				$this->Levels[$this->iflvl] = $this->LvlsPs[$this->iflvl] = 0;
			endif;
			return '';
		elseif (strcmp(strtok($line,' '),'endif')==0):
			$this->iflvl--;
			return '';
		elseif ($this->Levels[$this->iflvl]):
			return $line;
		else:
			return '';
		endif;
	}

	function is_equal($str)
	{
		if (($p = strpos($str,'=='))===false) return 1;
		$a = substr($str,0,$p);
		$b = substr($str,$p+2);
		return (strcasecmp($a,$b)==0);
	}
	
	function insert_constant($spec,$chars,$b,$e)
	{
		GLOBAL $CONFIG;
		$const = substr($chars,$b+1,$e-$b-1);
		$value = isset($CONFIG->Constants[$const])?$CONFIG->Constants[$const]:'';
		$spec_n = substr($spec,0,$b);
		$s = strlen($value);
		for ($i=0;$i<$s;$i++) $spec_n.= chr(0);
		$spec_n.= substr($spec,$e+1);
		$chars = substr($chars,0,$b).$value.substr($chars,$e+1);
		return array($spec_n,$chars);
	}

	function read_and_translate($line)
	{
		$s = strlen($line);
		$l_chars = '';
		$l_spec = '';
		$spec = 0;
		for ($i=0;$i<$s;$i++):
			$c = $line{$i};
			if (strcmp($c,'\\')==0):
				if ($spec):
					$spec = 0;
					$l_chars.= '\\';
					$l_spec.= chr(0);
				else:
					$spec = 1;
				endif;
			elseif(in_array($c,array('[',']','#'))):
				if ($spec):
					$l_chars.= $c;
					$l_spec.= chr(0);
					$spec = 0;
				else:
					$l_chars.= chr(0);
					$l_spec.= $c;
				endif;
			else:
				if ($spec):
					$l_chars.='\\';
					$l_spec.= chr(0);
					$spec = 0;
				endif;
				$l_chars.= $c;
				$l_spec.= chr(0);
			endif;
			if ($spec):
				$l_chars.='\\';
				$l_spec.= chr(0);
				$spec = 0;
			endif;
		endfor;
		if (($p = strpos($l_spec,'#'))!==false):
			$l_spec = substr($l_spec,0,$p);
			$l_chars = substr($l_chars,0,$p);
		endif;
		$s = strlen($l_spec);
		$bt = -1;
		$et = -1;
		for ($i = 0; $i < $s; $i++):
			switch($l_spec{$i}):
				case('['):
					$bt = $i;
					$et = -1;
					break;
				case(']');
					$et = $i;
					if ($bt!=-1):
						list($l_spec,$l_chars) = $this->insert_constant($l_spec,$l_chars,$bt,$et);
						$i = 0;
						$s = strlen($l_spec);
						$bt = -1;
					endif;
					break;
			endswitch;
		endfor;
		$result = '';
		$s = strlen($l_chars);
		for ($i=0;$i<$s;$i++):
			if (strcmp($l_chars{$i},chr(0))==0):
				if (strcmp($l_spec{$i},chr(0))!=0):
					$result.= $l_spec{$i};
				endif;
			else:
				$result.= $l_chars{$i};
			endif;
		endfor;
	//	$line=trim(strcmp(substr($line,0,1),'#')==0?'':strtok($line,'#'));
		return $result;
	}

	function Close()
	{
		fclose($this->file);
	}
}

class C_UserDef
{
	var $Vars;
	var $exists;
	
	function C_UserDef($Base,$UID)
	{
		$this->exists = 0;
		$reader = new C_configfile_reader($Base);
		while (($line = $reader->ReadStr())!==false)
		{
			$line=trim(strcmp(substr($line,0,1),'#')==0?'':strtok($line,'#'));
			if ($line)
			{
				list($key,$value) = split(' ',$line,2);
				$key = trim(strtolower($key));
				$value = trim($value);
				if (strcmp($key,'user')==0):
					if ($loaduser = (strcmp($UID,$value)==0)):
						$this->Vars['uid'] = $value;
						$this->exists = 1;
					endif;
				elseif($loaduser):
					$i = '';
					while (@$this->Vars[$key.$i]) $i++;
					$this->Vars[$key.$i] = $value;
				endif;
			}
		}
		$reader->Close();
	}
}

#class C_Users
#{
#	var $Vals;
#
#	function C_Users($filename)
#	{
#		$file = fopen($filename,'r') or die ("Could not open file $filename");
#		while ($line = fgets($file,10240))
#		{
#			$line=trim(strcmp(substr($line,0,1),'#')==0?'':strtok($line,'#'));
#			if ($line)
#			{
#				$this->Vals[] = new C_UserDef($line);
#			}
#		}
#		fclose($file);
#	}
#
#	function Valid_User($name,$password)
#	{
#		if (!$this->Vals) {return 0;}
#		foreach ($this->Vals as $user)
#		{ 
#			if ((strcmp($user->name,$name)==0) && (strcmp($password,$user->pwd)==0)) { return 1; }
#		}
#		return 0;
#	}
#
#	function FindUserNum($name)
#	{
#		if ($this->Vals):
#		for ($i=0;$this->Vals[$i];$i++)
#		{
#			if (strcasecmp($this->Vals[$i]->name,$name)==0):
#				return $i;
#			endif;
#		}
#		endif;
#		return -1;
#	}
#
#}

class C_Links
{
	var $LinkDef;
	var $Vals;
	var $Curr_ms;
	
	function C_Links($filename)
	{
		$linknew = 0;
		$reader = new C_configfile_reader($filename);
		while (($line = $reader->ReadStr())!==false)
		{
			$line=trim(strcmp(substr($line,0,1),'#')==0?'':strtok($line,'#'));
			if ($line)
			{
				@list($key,$value) = split(' ',$line,2);
				$key = trim(strtolower($key));
				$value = trim($value);
				if (strcmp($key,'linkdefaults')==0):
					$this->Addlink($linknew);
					$linknew=0;
				elseif (strcmp($key,'link')==0):
					$this->Addlink($linknew);
					$linknew=1;
					$this->Curr_ms['sysop']=$value;
				else:
					$i = '';
					while (isset($this->Curr_ms[$key.$i])) $i++;
					$this->Curr_ms[$key.$i] = $value;
				endif;
			}
		}
		$this->AddLink($linknew);
		$reader->Close();
		unset($this->Curr_ms);
	}

	function AddLink($linknew)
	{
		if ($this->Curr_ms)
		{
			if ($linknew):
				if ($this->LinkDef)
				{
				reset($this->LinkDef);
				while (list($key,$value)=each($this->LinkDef)):
					if (!isset($this->Curr_ms[$key]))
					{ $this->Curr_ms[$key]=$value; }
				endwhile;
				};
				$this->Vals[$this->Curr_ms['aka']]=$this->Curr_ms;
			else:
				reset($this->Curr_ms);
				while (list($key,$value)=each($this->Curr_ms)):
					$this->LinkDef[$key]=$value;
				endwhile;
			endif;
		}
		$this->Curr_ms = array();
	}
}

class C_AreaDef
{
	var $EchoTag;
	var $Path;
	var $Status;
	var $Links;
	var $Options;

	function C_AreaDef($line)
	{
	$vkh = 0;
	$line2 = '';
	if ($line):
		for ($i=0; $i<strlen($line); $i++):
			$c = substr($line,$i,1);
			if (strcmp($c,'"')==0):
		       		$vkh++;
			elseif ((strcmp(substr($line,$i,1),' ')==0) && ($vkh%2)):
				$c=chr(1);
			endif;
			$line2.=$c;
		endfor;
		$msv = split(' ',$line2);
		for ($i=0;$i<sizeof($msv);$i++) { $msv[$i] = str_replace(chr(1),' ',$msv[$i]); }
		$this->Status = array_shift($msv);
		$this->EchoTag = array_shift($msv);
		$this->Path = array_shift($msv);
		for ($i=0;$i<sizeof($msv); $i++)
		{
			if (strcmp(substr($msv[$i],0,1),'-')==0):
				$this->Options[$msv[$i]] = $msv[$i+1];
				$i++;
			else:
				$this->Links[] = $msv[$i];
			endif;
		}
	endif;
	}

	function AppendArea($fname)
	{
		tolog('Q',"Appending area {$this->EchoTag} to $fname");
		$line = $this->Status.' '.$this->EchoTag.' '.$this->Path;
		if ($this->Options):
		while (list($key,$value) = each($this->Options)):
			$line.=' '.$key.' '.$value;
		endwhile;
		endif;
		if ($this->Links):
		foreach ($this->Links as $item):
			$line.=" $item";
		endforeach;
		endif;
		$file = fopen($fname,'a') or die("Could not open file $fname");
		fwrite($file,"$line\n");
		fclose($file);
		return $line;
	}
}

class C_Areas
{
	var $Vals;
	var $Groups;

	function C_Areas($filename)
	{
		$reader = new C_configfile_reader($filename);
		while (($line = $reader->ReadStr())!==false)
		{
			$line=trim(strcmp(substr($line,0,1),'#')==0?'':strtok($line,'#'));
			if ($line)
			{
			if (strcasecmp(strtok($line,' '),'echogroup')==0):
				list($status,$name,$descr) = split(' ',$line,3);
				$this->Groups[$name] = $descr;
			else:
				$this->Vals[] = new C_AreaDef($line);
			endif;
			}
		}
		$reader->Close();
	}

	function AppendAreaToConf($line)
	{
		$this->Vals[] = new C_AreaDef($line);
	}
	
	function FindAreaNum($name)
	{
		if ($this->Vals):
		$sz = sizeof($this->Vals);
		for ($i=0;$i<$sz;$i++)
		{
			if (strcasecmp($this->Vals[$i]->EchoTag,$name)==0):
				return $i;
			endif;
		}
		endif;
		return -1;
	}
}

class C_CONFIG
{
	var $Links;
	var $Vars;
	var $Areas;
	var $FAreas;
	var $Constants;
	
	function Open($filename,$module = false)
	{
		GLOBAL $temp_dir;
		if ($module):
			$this->Constants['module'] = $module;
		else:
			$this->Constants['module'] = 'other';
		endif;
		$this->ReadCfgFile($filename);
		$temp_dir = $this->GetVar('tempdir');
	}

	function ReadCfgFile($filename)
	{
		$reader = new C_configfile_reader($filename);
		while (($line = $reader->ReadStr())!==false)
		{
			if ($line)
			{
				list($key,$value) = split(' ',$line,2);
				$key = trim(strtolower($key));
				$value = trim($value);
				if (strcmp($key,'set')==0):
					list($c,$v) = split('=',$value);
					$c = trim($c);
					$v = trim($v);
					if ((strcmp($c{0},'"')==0) && (strcmp($c{strlen($c)},'"')==0)):
						$c = substr($c,1,strlen($c)-2);
					endif;
					if ((strcmp($v{0},'"')==0) && (strcmp($v{strlen($v)},'"')==0)):
						$v = substr($v,1,strlen($c)-2);
					endif;
					$this->Constants[$c] = $v;
				elseif (strcmp($key,'includelinks')==0):
					$this->Links = new C_Links($value);
				elseif (strcmp($key,'includeareas')==0):
					$this->Areas = new C_Areas($value);
				elseif (strcmp($key,'includefareas')==0):
					$this->FAreas = new C_Areas($value);
#				elseif (strcmp($key,'includeusers')==0):
#					$this->Users = new C_Users($value);
				elseif (strcmp($key,'include')==0):
					$this->ReadCfgFile($value);
				else:
					$i = '';
					while (isset($this->Vars[$key.$i])) $i++;
					$this->Vars[$key.$i] = $value;
				endif;
			}
		}
		$reader->Close();
		unset($reader);
	}

	function GetVar($param)
	{
		if (isset($this->Vars[$param])):
			return $this->Vars[$param];
		else:
			return '';
		endif;
	}

	function GetLinkVar($addr,$param)
	{
		if (isset($this->Links->Vals[$addr][$param])):
			return $this->Links->Vals[$addr][$param];
		else:
			return '';
		endif;
	}

	function GetArray($param)
	{
		$cnt = '';
		$result = array();
		while(isset($this->Vars[$param.$cnt])):
			$result[]=$this->Vars[$param.$cnt];
			$cnt++;
		endwhile;
		return $result;
	}
}

function Error_handler($code, $msg, $errfile, $errline, $vars)
{	
	GLOBAL $CONFIG;
	#print "$errfile:$errline:$msg";
	if (isset($CONFIG)): 
		$arr = split(' ',$CONFIG->GetVar('errlogfile'),2);
		$file = $arr[0];
		$param = isset($arr[1])?$arr[1]:'';
		$writelog = 1;
		$errcrc = dechex(crc32("$code $msg $errfile $errline"));
		if ($writelog && (strstr($param,'-h')) && (error_reporting()==0)) $writelog = 0;
		if ($writelog && (strstr($param,'-q')) && is_readable($file)):
			if ($f = @fopen($file,'r')):
				while($line = fgets($f,1024)):
					if (strcasecmp('+'.$errcrc,trim($line))==0):
						$writelog = 0;
						break;
					endif;
				endwhile;
				fclose($f);
			endif;
		endif;
		if ($writelog && ($f = fopen($file,'a'))):
			fwrite($f,"+$errcrc\n");
			fwrite($f,"Error code: $code\n");
			fwrite($f,"Error msg: $msg\n");
			fwrite($f,"Error file: $errfile\n");
			fwrite($f,"Error line: $errline\n");
			fwrite($f,"=================\n");
			fclose($f);
			@chmod($file,0666);
		endif;
	endif;
	$msg = "(code $code) Error in $errfile:$errline message:\"$msg\"";
	tolog('-',$msg);
}

class C_LOG
{
	var $file;
	var $lvls;
	var $br;
	var $stdout;
	var $filename;

	function C_LOG($fname,$lvls,$br)
	{
		GLOBAL $PROGRAM;
		$this->stdout = (strcasecmp($fname,'stdout')==0);
		$this->lvls = $lvls;
		$br = str_replace('\r',"\r",$br);
		$br = str_replace('\n',"\n",$br);
		$this->br = $br;
		$this->filename = $fname;
		if (!$this->stdout && (!$this->file = fopen($fname,'a')))
			{ die("Open log file \"$fname\" failed!"); }

			$Time=date("r");
			$this->write('1'," *** Started: $Time ({$PROGRAM[0]}/{$PROGRAM[1]})");
	}
	
	function write($lvl,$message)
	{
		if (strpos($this->lvls,$lvl)||(strcmp($lvl,substr($this->lvls,0,1))==0)):
		$date = date("d M, H:i:s");
		if ($this->stdout):
			print("$lvl $date $message".$this->br);
		else:
			fwrite($this->file,"$lvl $date $message".$this->br);
		endif;	
		endif;
	}

	function done()
	{
		$Time=date("r, t");
		$this->write('1'," *** End: $Time");
		if (!$this->stdout) { 
			fclose($this->file); 
			@chmod($this->filename,0666);
		}
	}

	function refseek()
	{
		if (!$this->stdout):
		fseek($this->file,0,SEEK_END);
		endif;
	}
}

function initlog()
{
GLOBAL $CONFIG;
GLOBAL $LOGS;
$LOGS = array();
if (isset($CONFIG) && ($arr = $CONFIG->GetArray('logfile'))):
	foreach ($arr as $logfile):
		$logfarr = param_split($logfile);
		$fname = $logfarr[0];
		$lvls = isset($logfarr[1])?$logfarr[1]:'';
		$br = isset($logfarr[2])?$logfarr[2]:'\n';
		$LOGS[] = new C_LOG($fname,$lvls,$br);
	endforeach;
endif;
}

function tolog($lvl,$message)
{
GLOBAL $LOGS;
for ($i=0;$i<sizeof($LOGS);$i++):
$LOGS[$i]->write($lvl,$message);
endfor;
}

function donelog()
{
GLOBAL $LOGS;
for($i=0;$i<sizeof($LOGS);$i++) { $LOGS[$i]->done(); }
$LOGS = array();
}

function refseeklog()
{
GLOBAL $LOGS;
for($i=0;$i<sizeof($LOGS);$i++) { $LOGS[$i]->refseek(); }
}

?>
