<?

require_once "F_utils.php";

function Pkt_Report($tofile,$fromaddr,$fromname,$toaddr,$toname,$subject,$message_text)
{
	GLOBAL $CONFIG;
	$message = new Pkt_message();
	$toaddr = strtok($toaddr,'@');
	$fromaddr = strtok($fromaddr,'@');
	@list($ozone,$onet,$onode,$opoint) = split("[:/.]",$fromaddr);
	@list($dzone,$dnet,$dnode,$dpoint) = split("[:/.]",$toaddr);

	$cludge_top = chr(1)."INTL $dzone:$dnet/$dnode $ozone:$onet/$onode\r".
		chr(1)."MSGID: $fromaddr ".rand(10000000,99999999)."\r".
		($opoint?(chr(1)."FMPT $opoint\r"):'').
		($dpoint?(chr(1)."TOPT $dpoint\r"):'').
		chr(1)."TID: Pkt_Report function (c)Alex Kocharin";
	$cludge_bot = chr(1)."Via $fromaddr Pkt_Report ".date('d M Y H:i:s');
	
	$message->Version = 2;
	$message->OrigNode = $onode;
	$message->DestNode = $dnode;
	$message->OrigNet = $onet;
	$message->DestNet = $dnet;
	$message->Attr = 0;
	$message->Cost = 0;
	$message->AsciiDate = date('d M y  H:i:s');
	$message->ToUser = $toname;
	$message->FromUser = $fromname;
	$message->Subject = $subject;
	$message->MsgText = $cludge_top."\r".$message_text."\r".$cludge_bot;
	$pkt = new FidoPacket;
	if ($pkt->Open($tofile)):
		$pkt->Unclose();
	else:
		$pkt->NewPacket($tofile,$fromaddr,$toaddr,'');
	endif;
	$pkt->message = $message;
	$pkt->AppendMessage();
	$pkt->FinishPacket();
	unset($message);
	unset($pkt);
}

class Pkt_hat
{
	var $OrigNode;
	var $DestNode;
	var $Year;
	var $Month;
	var $Day;
	var $Hour;
	var $Minute;
	var $Second;
	var $rate;
	var $Version;
	var $OrigNet;
	var $DestNet;
	var $PCodeLo;
	var $PRevMajor;
	var $Password;
	var $QMOrigZone;
	var $QMDestZone;
	var $AuxNet;
	var $CWValidate;
	var $PCodeHi;
	var $PRevMinor;
	var $CWCapWord;
	var $OrigZone;
	var $DestZone;
	var $OrigPoint;
	var $DestPoint;
	var $LongData;
	
	function Open($file)
	{
		$this->OrigNode = fgetint($file,2);
		$this->DestNode = fgetint($file,2);
		$this->Year = fgetint($file,2);
		$this->Month = fgetint($file,2);
		$this->Day = fgetint($file,2);
		$this->Hour = fgetint($file,2);
		$this->Minute = fgetint($file,2);
		$this->Second = fgetint($file,2);
		$this->rate = fgetint($file,2);
		$this->Version = fgetint($file,2);
		$this->OrigNet = fgetint($file,2);
		$this->DestNet = fgetint($file,2);
		$this->PCodeLo = fgetint($file,1);
		$this->PRevMajor = fgetint($file,1);
		$this->Password = fread($file,8);
		$this->QMOrigZone = fgetint($file,2);
		$this->QMDestZone = fgetint($file,2);
		$this->AuxNet = fgetint($file,2);
		$this->CWValidate = fgetint($file,2);
		$this->PCodeHi = fgetint($file,1);
		$this->PRevMinor = fgetint($file,1);
		$this->CWCapWord = fgetint($file,2);
		$this->OrigZone = fgetint($file,2);
		$this->DestZone = fgetint($file,2);
		$this->OrigPoint = fgetint($file,2);
		$this->DestPoint = fgetint($file,2);
		$this->LongData = fgetint($file,4);
	}

	function WriteHdr($file,$fromaddr,$toaddr,$password)
	{
		$from_msv = split('[\:\/\.]',strtok($fromaddr,'@'));
		$to_msv = split('[\:\/\.]',strtok($toaddr,'@'));
		$cur_date = getdate();
		fputint($file,2,$from_msv[2]); # OrigNode
		fputint($file,2,$to_msv[2]); # DestNode
		fputint($file,2,$cur_date['year']); # Year
		fputint($file,2,$cur_date['mon']-1); # Month
		fputint($file,2,$cur_date['mday']); # Day
		fputint($file,2,$cur_date['hours']); # Hour
		fputint($file,2,$cur_date['minutes']); # Minute
		fputint($file,2,$cur_date['seconds']); # Second
		fputint($file,2,0); # rate
		fputint($file,2,2); # Version
		fputint($file,2,$from_msv[1]); # OrigNet
		fputint($file,2,$to_msv[1]); # DestNet
		fputint($file,1,0); # PCodeLo
		fputint($file,1,0); # PRevMajor
		fputstr($file,$password,8); # Password
		fputint($file,2,$from_msv[0]); # QMOrigZone
		fputint($file,2,$to_msv[0]); # QMDestZone
		fputint($file,2,0); # AuxNet
		fputint($file,2,0); # CWValidate
		fputint($file,1,0); # PCodeHi
		fputint($file,1,2); # PRevMinor
		fputint($file,2,0); # CWCapWord
		fputint($file,2,isset($from_msv[0])?$to_msv[0]:0); # OrigZone
		fputint($file,2,isset($to_msv[0])?$to_msv[0]:0); # DestZone
		fputint($file,2,isset($from_msv[3])?$from_msv[3]:0); # OrigPoint
		fputint($file,2,isset($to_msv[3])?$to_msv[3]:0); # DestPoint
		fputint($file,4,0); # LongData
	}
}

class Pkt_message
{
	var $Version;
	var $OrigNode;
	var $DestNode;
	var $OrigNet;
	var $DestNet;
	var $Attr;
	var $Cost;
	var $AsciiDate;
	var $ToUser;
	var $FromUser;
	var $Subject;
	var $MsgText;

	function Read_message($file)
	{
		$this->Version = fgetint($file,2);
		if ($this->Version != 0):
		$this->OrigNode = fgetint($file,2);
		$this->DestNode = fgetint($file,2);
		$this->OrigNet = fgetint($file,2);
		$this->DestNet = fgetint($file,2);
		$this->Attr = fgetint($file,2);
		$this->Cost = fgetint($file,2);
		$this->AsciiDate = fgetasciiz($file);
		$this->ToUser = fgetasciiz($file);
		$this->FromUser = fgetasciiz($file);
		$this->Subject = fgetasciiz($file);
		$this->MsgText = fgetasciiz($file);
		endif;
	}
	

	function Write_message($file)
	{
		fputint($file,2,$this->Version);
		fputint($file,2,$this->OrigNode);
		fputint($file,2,$this->DestNode);
		fputint($file,2,$this->OrigNet);
		fputint($file,2,$this->DestNet);
		fputint($file,2,$this->Attr);
		fputint($file,2,$this->Cost);
		fputasciiz($file,$this->AsciiDate);
		fputasciiz($file,$this->ToUser);
		fputasciiz($file,$this->FromUser);
		fputasciiz($file,$this->Subject);
		fputasciiz($file,$this->MsgText);
	}
}

class FidoPacket
{
	var $pkt_hat;
	var $file;
	var $filename;
	var $message;
	
	function Open($filename)
	{
		tolog('c',"Opening packet $filename");
		$this->filename = $filename;
		if ($this->file = @fopen($filename,'r+')):
			$this->pkt_hat = new Pkt_hat;
			$this->pkt_hat->Open($this->file);
			return 1;
		else:
			return 0;
		endif;
	}

	function Close()
	{
		tolog('c','Closing packet');
		fclose($this->file);
	}

	function ReadMessage()
	{
		tolog('m','Reading next message');
		$message = new Pkt_message;
		$message->Read_message($this->file);
		return $message;
	}

	function NewPacket($filename,$fromaddr,$toaddr,$password)
	{
		tolog('c',"Writing packet $filename");
		$this->filename = $filename;
		$this->file = fopen($filename,'w') or die('Could not open file "'.$filename.'"');
		$pkt_hat = new Pkt_hat;
		$pkt_hat->WriteHdr($this->file,$fromaddr,$toaddr,$password);
		$this->message = new Pkt_message;
	}

	function AppendMessage()
	{
		$this->message->Write_message($this->file);
	}

	function FinishPacket()
	{
		fwrite($this->file,chr(0).chr(0));
		$this->Close();
		chmod($this->filename,0666);
	}

	function Unclose()
	{
		fseek($this->file,-2,2);
	}
}
	
?>
