<?

function Get_address($addr_msv)
{
$res=$addr_msv[0].':'.$addr_msv[1].'/'.$addr_msv[2].($addr_msv[3]?'.'.$addr_msv[3]:'');
return $res;
}

function Fts_date_to_unix($date)
{
	$months = array('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	$msv = split('[ \:]',$date);
	for($i=0;$i<12;$i++){if (strcasecmp($months[$i],$msv[1])==0){$msv[1] = ($i+1); }}
	return mktime($msv[4],$msv[5],$msv[6],$msv[1],$msv[0],$msv[2]);
}

function Mysql_date_to_unix($date)
{
	$msv = split('[-\: ]',$date);
	return mktime($msv[3],$msv[4],$msv[5],$msv[1],$msv[2],$msv[0]);
}

function send_file_to_brw($name)
{
	GLOBAL $Nosend_Tobrw;
	$Nosend_Tobrw = 1;
	$zipname = addslashes($name);
	header("Content-Type: application/zip; name=\"$zipname\"");
	header("Content-Disposition: attachment; filename=\"$zipname\"");
	readfile($name);
}

class C_Matrix
{
	var $Value;
	var $size;

	function set($y,$x,$v)
	{
		$this->Value[$y][$x] = $v;
		if ($y>$this->size-1) { $this->size = $y+1; }
	}

	function get($y,$x)
	{
		return $this->Value[$y][$x];
	}
	
	function write($y,$x,$val)
	{
		$len = strlen($val);
		for ($i=0;$i<$len;$i++):
		$this->Value[$y][$i+$x] = substr($val,$i,1);
		endfor;
		if ($y>$this->size-1) { $this->size = $y+1; }
	}

	function join()
	{
	for ($i=1;$i<=$this->size;$i++):
		for ($j=80;$this->Value[$i][$j];$j--);
		for ($k=1;$k<$j;$k++):
			$result.=(strcmp($this->Value[$i][$k],'')!=0?$this->Value[$i][$k]:' ');
		endfor;
		$result.="\n";
	endfor;
	return $result;
	}
}

function prints($arg)
{
	GLOBAL $To_browser;
	$To_browser.= $arg;
}

function get_h_size($size)
{
	if ($size > 10*(1 << 30)) { $size = ($size >> 30).'G'; }
	elseif ($size > 10*(1 << 20)) { $size = ($size >> 20).'M'; }
	elseif ($size > 10*(1 << 10)) { $size = ($size >> 10).'K'; }
	return $size;
}

function fgetint($file,$len)
{
	$result=0;
	for ($i=0;$i<$len;$i++):
		$result+=(ord(fgetc($file)) << ($i*8));
	endfor;
	return $result;
}

function fputint($file,$len,$data)
{
	$result='';
	for ($i=0;$i<$len;$i++):
		$result.=chr(($data >> ($i*8)) & 255);
	endfor;
	fwrite($file,$result);
}

function fgetasciiz($file)
{
	$result='';
	$char = fgetc($file);
	while (ord($char)!=0):
		$result.=$char;
		$char = fgetc($file);
	endwhile;
	return $result;
}

function fputasciiz($file,$data)
{
	fwrite($file,$data);
	fwrite($file,chr(0));
}

function fputstr($file,$str,$len)
{
	if (strlen($str)>$len) $str = substr($str,0,$len);
	$str2 = $str;
	for ($i=strlen($str);$i<$len;$i++)
	{
		$str2.=chr(0);
	}
	fwrite($file,$str2);
}

function getfirstline($message)
{
 $txt=strtok($message,chr(13));
 while (strcmp(substr($txt,0,1),chr(1))==0):
  $txt=strtok(chr(13));
 endwhile;
 return $txt;
}

function GetEchoDescrFromEcholist($area)
{
	GLOBAL $CONFIG;
	$result = '';
	if (is_readable($CONFIG->GetVar('echolist'))):
		$file = fopen($CONFIG->Vars['echolist'],'r');
		while ($line = fgets($file,1024)):
			list($status,$echotag,$descr,$moderator,$address) = split(',',$line);
			if (strcasecmp($echotag,$area)==0):
				$result = $descr;
			endif;
		endwhile;
		fclose($file);
	endif;
	return $result;
}

function pc_mkdir_parents($d,$umask = 0777) {
    $dirs = array($d);
    $d = dirname($d);
    $last_dirname = '';
    while($last_dirname != $d) { 
        array_unshift($dirs,$d);
        $last_dirname = $d;
        $d = dirname($d);
    }

    foreach ($dirs as $dir) {
        if (! file_exists($dir)) {
            if (! mkdir($dir,$umask)) {
                error_log("Can't make directory: $dir");
                return false;
            }
        } elseif (! is_dir($dir)) {
            error_log("$dir is not a directory");
            return false;
        }
    }
    return true;
}

?>
